header
{
/**
 * Parser for the Mile language.
 * 
 * @author Ricardo Soto
 * @since 1.5
 */

package cl.ucv.inf.mileppcompiler.compilers;

}
//======================================================
// Object allowing syntactic analysis

class MilePPParser extends Parser;
options
{
    k = 2;
    importVocab = MilePPLexerVocab;
    exportVocab = MilePPParserVocab;
    buildAST = true;
    defaultErrorHandler=false;
}


tokens
{
//=======================================================
// Imaginary Tokens 


    PROGRAM;
    PARAM;
    UN_MINUS;



}

//======================================================= 
//Main rule

program : main_class_dec (class_dec)*
          {## = #( #[PROGRAM, "PROGRAM"] ,##);}
        ;
        

//======================================================= 
//Class declarations
        
main_class_dec : MAIN_RW^ class_dec;

class_dec : CLASS_RW^ IDENT (EXTENDS_RW IDENT)? 
            LEFT_PAREN! (param)? RIGHT_PAREN!
            LEFT_BRACE! class_body RIGHT_BRACE!;

param :  type IDENT (COMMA type IDENT)* 
         {## = #( #[PARAM, "PARAM"] ,##);};
                 
basic_type:   (NUMERIC_TYPE|STRING_TYPE) ;

class_body:;
type:;

//=======================================================
//Expressions 


expr          :  expAND  (OR_RW^ expAND)*;

expAND        :  expCons (AND_RW^ expCons)*;

expCons       :  expSum  ((EQUAL^| 
                           LE_EQUAL^|
                           GR_EQUAL^|
                           NOT_EQUAL^|
                           GR^|
                           LE^) expSum)* ; 

expSum        :  expProduct  ((PLUS^| 
                               SUB^) expProduct)* ; 

expProduct    :  expMinus ((STAR^ | 
                            SLASH^) expMinus)* ;  

expMinus      : (SUB! expNot)
                { ##=#(#[UN_MINUS, "UN_MINUS"], ##) ;} 
              | ((PLUS!)? expNot)
              ;

expNot: (NOT_RW^)? (IDENT|lit|(LEFT_PAREN! expr RIGHT_PAREN!));

lit: REAL_LITERAL|INT_LITERAL;




